/* gpenguin - display a penguin and some system info. azz@josstix.demon.co.uk
   Functions to read info nicked unashamedly from linux_logo. */

#include <gtk/gtk.h>
#include <glib.h>
#include <stdio.h>
#include <string.h>

/* The penguin logo. */
#include "tux-small-16.xpm"
#define penguin_xpm tux_small_16_xpm

GtkWidget *window, *hbox, *penguin, *vbox, *llinux, *lcpu, *lbogo, *lram, *lhost,
  *fhost, *bhost, *flinux, *blinux, *fcpu, *bcpu, *fram, *bram;
char slinux[100], scpu[100], sbogo[100], sram[100], shost[100];
GdkPixmap *pixmap;
GdkBitmap *mask;
GtkStyle *style;

char os_name[65], host_name[65], os_version[65], os_revision[65];
char cpu_info[65], bogo_total[65], ram_info[65];

void get_os_info(char *a, char *b, char *c, char *d);
void get_hardware_info(char *a, char *b, char *d, int c);

gint finish(gpointer data) {
  gtk_main_quit();
  return(FALSE);
}

gint handle_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data) {
  return(FALSE); /* Close the window, as FALSE */
}

void handle_destroy(GtkWidget *widget, gpointer data) {
  gtk_main_quit();
}

int main(int argc, char **argv) {

  gtk_init(&argc, &argv);

  window = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(window), "gpenguin");
  gtk_window_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		     GTK_SIGNAL_FUNC(handle_delete_event), NULL);
  gtk_signal_connect(GTK_OBJECT(window), "destroy",
		     GTK_SIGNAL_FUNC(handle_destroy), NULL);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(window), hbox);

  style = gtk_widget_get_style(window);
  pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask,
					&style->bg[GTK_STATE_NORMAL],
					(gchar **)penguin_xpm);
  penguin = gtk_pixmap_new(pixmap, mask);
  gtk_box_pack_start(GTK_BOX(hbox), penguin, TRUE, TRUE, 0);
  gtk_widget_show(penguin);

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 5);

#define NEWFRAME(x,y,l) x=gtk_frame_new(l);gtk_box_pack_start(GTK_BOX(vbox),x,FALSE,FALSE,0);y=gtk_vbox_new(FALSE,0);gtk_container_add(GTK_CONTAINER(x),y);gtk_widget_show(y);
#define NEWLABEL(f,x,y) x=gtk_label_new(y);gtk_box_pack_start(GTK_BOX(f),x,FALSE,FALSE,0);gtk_widget_show(x);

  get_os_info(os_name, os_version, os_revision, host_name);
  get_hardware_info(cpu_info, bogo_total, ram_info, 0);

  NEWFRAME(fhost, bhost, "Hostname");
  sprintf(shost, "%s", host_name);
  NEWLABEL(bhost, lhost, shost);

  NEWFRAME(flinux, blinux, "OS");
  sprintf(slinux, "%s %s", os_name, os_version);
  NEWLABEL(blinux, llinux, slinux);

  NEWFRAME(fcpu, bcpu, "CPU");
  sprintf(scpu, "%s", cpu_info);
  NEWLABEL(bcpu, lcpu, scpu);
  sprintf(sbogo, "%s bogomips", bogo_total);
  NEWLABEL(bcpu, lbogo, sbogo);

  NEWFRAME(fram, bram, "Memory");
  sprintf(sram, "%s RAM", ram_info);
  NEWLABEL(bram, lram, sram);

  gtk_widget_show(bram);
  gtk_widget_show(bcpu);
  gtk_widget_show(blinux);
  gtk_widget_show(bhost);
  gtk_widget_show(fram);
  gtk_widget_show(fcpu);
  gtk_widget_show(flinux);
  gtk_widget_show(fhost);
  gtk_widget_show(vbox);
  gtk_widget_show(hbox);
  gtk_widget_show(window);

  gtk_timeout_add(5000, finish, NULL);

  gtk_main();
  exit(0);
}
